#include "Sender.h"

const int Sender::domain=AF_INET; // Init. This is so stupid (c++)
const int Sender::typ=SOCK_STREAM;
// private
 
    int Sender::constr_name(struct sockaddr_in& addr, const char* hostnm) {
	// Fill in the address struct. Ugh this is ugly!
	addr.sin_family=domain;
	struct hostent *hp;
	cerr << hostnm;
	hp=gethostbyname(hostnm);
	if(hp==0) {
	    perror("gethostbyname");
	    return -1;
	}
	memcpy((char*) &addr.sin_addr, (char*)  hp->h_addr, hp->h_length);
	addr.sin_port=htons(port);
	return sizeof(addr);
    }
   
    void Sender::initSock() {
	// creates the socket and opens the connection.
	if ((sid=socket(domain,typ,0))<0) perror("socket"); // socket creation.
	int optval=1;
	setsockopt(sid, IPPROTO_TCP, TCP_NODELAY,&optval ,0 ); // disable nagle, does it work?
	cerr << "\nSocketID: " << sid << '\n';
	struct sockaddr_in addr;
	int len=constr_name(addr, servName);

	if(connect(sid, (struct sockaddr*) &addr, len)<0) perror("connect");
    }

//  public:
    Sender::Sender(char* sN, short int p) {   
	servName=new char[128];
	strcpy(servName,sN);
	port=p;
	initSock();
    }
    
    int Sender::forward(char* data, int len) {
      int r=send(sid, data, len, 0); // 0 is a flag (?)
      //cerr << "\nSent: " << r; 
      // flush();
      return r;

    }

    int Sender::read() {
	// Testing, reads what it gets an prints it.
	int ret;
	char* rBuf[128];
	rBuf[0]='\0';
	ret=recv(sid,rBuf,128,0);
	cerr << "\nR: " << (char*) rBuf;
	return ret;
    }

    int Sender::finish() {
	int ret;
	ret=shutdown(sid,2); // close socket for r&w
	close(sid);
	return ret;
    }
   
// int main() {

// //     char* n=new char[128];
// //     gethostname(n,128);

//     char* d="blubba";
//     char* n="asterix";

//     cerr << "\nServer: "<< n;

//     Sender s(n, 7); // connect to echo
//     s.forward(d,7);
//     s.read();
//     s.forward(d,3);
//     s.read();
//     s.finish();
// };
// compile with:  CC Sender.cpp -l socket -l nsl
