//#include <stream.h> // !
//#include "FastTestParser.cpp" // for performance tests
#include "FastParser.cpp"

#include "Sender.h"

int main(int argc, char **argv) {
    char* name="balu";
    int port=3330;

    if(argc>1) {
	name=argv[1] ;
	if(argc>2) port=atoi(argv[2]); 
    }


    cerr << "\nConnecting to server: "<< name << " on port: " << port;
    Sender s(name, port); // connect to java daemon
    FastParser p(s); // p; p(s)
    p.parse();
    s.finish();

}
// Compiling for Linux:
// g++ -c FastParser.cpp ...
// g++ FastMain.C FastParser.o Sender.o
// Compiling for Solaris:
// module load compiler
// CC -c FastParser.cpp ...
// CC -l socket -l nsl Main.C FastParser.o Sender.o
