//#include <stream.h> // !
//#include "TestParser.cpp" // for performance tests
#include "Parser.cpp"

#include "Sender.h"


int reserved=10;// the first 10 bytes are reserved for len (see Parser.cpp)

int main(int argc, char **argv) {
    char* name="balu";
    int port=3330;

    if(argc>1) {
	name=argv[1] ;
	if(argc>2) port=atoi(argv[2]); 
    }


    cerr << "\nConnecting to server: "<< name << " on port: " << port;
    Sender s(name, port); // connect to java daemon
    Parser p(s); // p;
    p.parse();
    s.finish();

}
// Compiling for Linux:
// g++ -c Parser.cpp ...
// g++ Main.C Parser.o Sender.o
// Compiling for Solaris:
// module load compiler
// CC -c Parser.cpp ...
// CC -l socket -l nsl Main.C Parser.o Sender.o
